package com.muyu.data.base;


/**
 * 基础查询
 */
public class BaseQueryHandler {
    private static final ThreadLocal<BaseQuery> BASE_QUERY_THREAD_LOCAL = new ThreadLocal<>();

    public static void set(BaseQuery baseQuery){
        BASE_QUERY_THREAD_LOCAL.set(baseQuery);
    }

    public static <T> T  get(){
        return (T) BASE_QUERY_THREAD_LOCAL.get();
    }

}
