package com.muyu.domain.mysql;

/**
 * 提供一个连接池的准则
 */
public interface BasePool<T> {
    //初始化
    public void init();
    //获取连接
    public T getConn();
    //归还连接
    public void replease(T conn);
    //创建连接
    public T createConn();
    //关闭连接
    public void closeConn();
}
