package com.muyu.cloud.etl.controller;


import com.muyu.cloud.etl.service.SourceTypeService;
import com.muyu.common.core.domain.Result;
import com.muyu.common.core.web.controller.BaseController;
import com.muyu.domain.SourceType;
import com.muyu.domain.mysql.config.MysqlPoolConfig;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/SourceType")
public class SourceTypeController extends BaseController {
    @Autowired
    private SourceTypeService sourceTypeService;

    //查询
    @GetMapping("/findSourceType")
    public Result<List<SourceType>> findSourceType() {
        List<SourceType> sourceTypeList=sourceTypeService.findSourceType();
        return Result.success(sourceTypeList);
    }

    // 数据源连接池测试连接
    @PostMapping("TextSourcePool")
    public Boolean TextSourcePool(@RequestBody MysqlPoolConfig mysqlPoolConfig) {
        return  sourceTypeService.TextSourcePool(mysqlPoolConfig);
    }









}
