package com.muyu.cloud.etl.service;

import com.muyu.domain.Accredit;
import com.muyu.domain.rep.AccreditDeptRep;
import com.muyu.domain.rep.AccreditUserRep;
import com.muyu.domain.req.AccreditReq;

import java.util.List;

public interface AccreditService {
    Accredit findAccredit(Long tableId);

    List<AccreditDeptRep> findDeptListStatus(Long tableId, Long basicId);

    List<AccreditUserRep> findUserListStatus(Long tableId, Long basicId);

    Integer addMiddle(AccreditReq accreditReq);

    Integer remove(AccreditReq accreditReq);

    List<Integer> findUserTableIds(Long userId);

    List<Integer> findDeptTableIds(Long deptId);

}
